<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Exception;
use App\Models\Team;
use Illuminate\View\View;
use App\Models\TeamDescription;
use App\Services\Response\ResponseService;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use App\Http\Requests\Admin\TeamRequest;
use Illuminate\Http\RedirectResponse;
use Mcamara\LaravelLocalization\Facades\LaravelLocalization;

class TeamController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/teams';
    /** View folder */
    private $viewDirectory= 'admin.teams.';

    /**
     * Display a listing of the resource.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('teams.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the pages.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Team::latest()
            ->join('team_descriptions AS ad', 'teams.id', 'ad.team_id')
            ->join('languages', 'languages.id', 'ad.language_id')
            ->where('local', LaravelLocalization::getCurrentLocale())
            ->select(['ad.name', 'teams.*']);

        if ($request->date_from) {
            $query->whereDate('teams.created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('teams.created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('ad.name', 'LIKE', '%'.$request->name.'%');
        }
        if ($request->type) {
            $query->where('type', $request->type);
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $teams= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('teams'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('teams.store');
        $head= __('teams.new');
        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param TeamRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(TeamRequest $request)
    {
        $team = Team::create($request->all());


        // Insert Description
        $this->saveData($request, $team->id);

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('teams.index'),
        ];
        return ResponseService::response($response);
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param Team $team
     * @return View
     */
    public function edit(Team $team) :View
    {
        $action= route('teams.update', $team->id);

        $query = TeamDescription::where('team_id', $team->id)
            ->join('languages', 'languages.id', 'team_descriptions.language_id')
            ->select(['team_descriptions.*', 'languages.local']);
        $head= __('teams.edit');

        $teamDescription= $query->get();

        foreach ($teamDescription as $row) {
            $team[$row->local]= $row;
        }

        return view( $this->viewDirectory.'form', compact('team', 'action','head') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param TeamRequest $request
     * @param Team $team
     * @return RedirectResponse|Redirector
     */
    public function update(TeamRequest $request, Team $team)
    {

        // Update image and category id if request has it

        $team->update($request->all());



        // Delete old description
        TeamDescription::where('team_id', $team->id)->delete();

        // Insert new description
        $this->saveData( $request, $team->id );

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('teams.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Handle Save form data
     *
     * @param TeamRequest $request
     * @param int $team_id
     * @return void
     */

    private function saveData(TeamRequest $request, int $team_id ):void
    {

        $requestData= $request->all();
        foreach (languages() as $lang) {
            $data=[
                'team_id'=> $team_id,
                'language_id'=> $lang->id,
                'name'=> $requestData['name_'.$lang->local],
                'job'=> $requestData['job_'.$lang->local],
            ];
            TeamDescription::create($data);
        }
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $team = Team::withTrashed()->find($id);
        if ($team) {
            if ($team->deleted_at) {
                $team->forceDelete();
            } else {
                $team->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Team::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Team::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $team = Team::withTrashed()->find($id);

        if ($team){
            $team->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $team = Team::whereIn('id', $request->ids)->onlyTrashed();
        if ($team){
            $team->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.saveDone')]);
    }
}
